elftosb::MemoryImageDataSource::FillSegment Class Reference

Segment corresponding to a fill region of the executable image. More...

`#include <DataSource.h>`

Inheritance diagram for elftosb::MemoryImageDataSource::FillSegment:
[legend]
Collaboration diagram for elftosb::MemoryImageDataSource::FillSegment:
[legend]

## Public Member Functions

| FillSegment (MemoryImageDataSource &source, StExecutableImage *image, unsigned index)
virtual unsigned | getLength ()
| Returns a length based on the data target's address range. More...
virtual bool | hasNaturalLocation ()
| Pattern segments have no natural address.
virtual uint32_t | getBaseAddress ()
| Returns the address associated with the segment.
Public Member Functions inherited from elftosb::DataSource::PatternSegment
| PatternSegment (DataSource &source)
| Default constructor.
| PatternSegment (DataSource &source, const SizedIntegerValue &pattern)
| Constructor taking a fill pattern.
| PatternSegment (DataSource &source, uint8_t pattern)
| Constructor taking a byte fill pattern.
| PatternSegment (DataSource &source, uint16_t pattern)
| Constructor taking a half-word fill pattern.
| PatternSegment (DataSource &source, uint32_t pattern)
| Constructor taking a word fill pattern.
virtual unsigned | getData (unsigned offset, unsigned maxBytes, uint8_t *buffer)
| Performs a pattern fill into the buffer.
void | setPattern (const SizedIntegerValue &newPattern)
| Assigns a new fill pattern.
SizedIntegerValue & | getPattern ()
| Return the fill pattern for the segment.
PatternSegment & | operator= (const SizedIntegerValue &value)
| Assignment operator, sets the pattern value and length.
Public Member Functions inherited from elftosb::DataSource::Segment
| Segment (DataSource &source)
| Default constructor.
virtual | ~Segment ()
| Destructor.

## Protected Attributes

StExecutableImage * | m_image
| Coalesced image of the file.
unsigned | m_index
| Record index.
Protected Attributes inherited from elftosb::DataSource::PatternSegment
SizedIntegerValue | m_pattern
| The fill pattern.
Protected Attributes inherited from elftosb::DataSource::Segment
DataSource & | m_source
| The data source to which this segment belongs.

## Detailed Description

Segment corresponding to a fill region of the executable image.

## Member Function Documentation

unsigned MemoryImageDataSource::FillSegment::getLength | ( |  | ) |

virtual

Returns a length based on the data target's address range.

The pattern segment's length is a function of the data target. If the target is bounded, then the segment's length is simply the target's length. Otherwise, if no target has been set or the target is unbounded, then the length returned is 0.

Reimplemented from elftosb::DataSource::PatternSegment.

The documentation for this class was generated from the following files:

- apps/elftosb/common/DataSource.h
- apps/elftosb/common/DataSource.cpp